/*
 * $Id: $
 */
package com.neurothemis.xmlswarm.dom;

import org.w3c.dom.Attr;
import org.w3c.dom.Node;
import org.w3c.dom.Document;

/**
 * PersistentAttr implementation of w3c Attr
 *
 * @author Guillaume BINET <gbin@netcourrier.com>
 * @version $Revision: $
 */

public class PersistentAttr extends PersistentNode implements Attr 
{
  private boolean specified=false;
   
  public PersistentAttr(Document doc, String name)
  {
     super(doc, Node.ATTRIBUTE_NODE, name);
  }
  
  public String getName()
  {
     return super.getNodeName();
  }
     
  public boolean getSpecified()
  {
     return specified;
  }
  
  public String getValue()
  {
     return super.getNodeValue();
  }
  
  public void setValue(String value)
  {
     specified=true;
     super.setNodeValue(value);
  }
}

