/*
 * $Id: $
 */
package com.neurothemis.xmlswarm.dom;

import org.w3c.dom.ProcessingInstruction;
import org.w3c.dom.DOMException;
import org.w3c.dom.Document;
import org.w3c.dom.Node;

/**
 * ProcessingInstruction Implementation of w3c ProcessingInstruction class
 *
 * @author Guillaume BINET <gbin@netcourrier.com>
 * @version $Revision: $
 */
public class PersistentProcessingInstruction extends PersistentNode implements ProcessingInstruction 
{
   
   private String target;
   private String data;

   public PersistentProcessingInstruction(Document doc, String name)
   {
      super(doc, Node.PROCESSING_INSTRUCTION_NODE, name);
   }

   public String getTarget()
   {
      return target;
   }

   public void setTarget(String target)
   {
      this.target=target;
   }



   public String getData()
   {
      return data;
   }

   public void setData(String data) throws DOMException
   {
      this.data=data;
   }

}

