/*
 * $Id: $
 */
package com.neurothemis.xmlswarm.dom;

import org.w3c.dom.Text;
import org.w3c.dom.DOMException;
import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * PersistentText Implementation of w3c Text class
 *
 * @author Guillaume BINET <gbin@netcourrier.com>
 * @version $Revision: $
 */
public class PersistentText extends PersistentCharacterData implements Text
{
   public PersistentText(Document doc, short type, String name)
   {
      super(doc, type, name);
   }
   
   public String getNodeName() 
   {
        return "#text";
   }

   public PersistentText(Document doc, String name)
   {
      super(doc, Node.TEXT_NODE, name);
   }

   public Text splitText(int offset) throws DOMException
   {
      if (offset < 0 || offset > value.length() - 1) 
      {
         throw new PersistentDOMException(DOMException.INDEX_SIZE_ERR, 
       	                           "DOM004 Index out of bounds");
      }
       		
      // split text into two separate nodes
      Text newText = associatedDocument.createTextNode(value.substring(offset));
      
      value = value.substring(0, offset);
   
      // insert new text node
      if (parent != null) 
      {
         parent.insertBefore(newText, getNextSibling());
      }
   
      return newText;
   }
}

