//-< Conversion.java >-----------------------------------------------*--------*
// GOODS                      Version 2.02       (c) 1998  GARRET    *     ?  *
// (Generic Object Oriented Database System)                         *   /\|  *
// Java Program Interface                                            *  /  \  *
//                          Created:     22-Oct-98    K.A. Knizhnik  * / [] \ *
//                          Last update: 22-Oct-98    K.A. Knizhnik  * GARRET *
//-------------------------------------------------------------------*--------*
// Some primitives for providing compatibilities with C++ data type
//-------------------------------------------------------------------*--------*

package goodsjpi;

public class Conversion { 
    /** 
     * Conversion of zero terminated C++ string to Java Unicode String.
     * High byte of unicode character is set to 0, so only ASCII characters
     * will be corretly converted by this function. 
     */
    public static String AsciizToString(byte[] b) { 
	return new String(b, 0, 0, b.length - 1);
    }
	
    public static byte[] StringToAsciiz(String s) { 
	int length = s.length();
	byte[] b = new byte[length+1];
	s.getBytes(0, length, b, 0);
	b[length] = 0;
	return b;
    }
}
