//-< PersistentComparator.java >-------------------------------------*--------*
// GOODS                      Version 2.02       (c) 1998  GARRET    *     ?  *
// (Generic Object Oriented Database System)                         *   /\|  *
// GOODS Persistent Class Library                                    *  /  \  *
//                          Created:     16-Oct-2000  K.A. Knizhnik  * / [] \ *
//                          Last update: 16-Oct-2000  K.A. Knizhnik  * GARRET *
//-------------------------------------------------------------------*--------*
// Abstract base class for all persistent objects which can be used as comparators
//-------------------------------------------------------------------*--------*

package goodslib;
import goodsjpi.Persistent;
import java.util.Comparator;

/**
 * Abstract base class for all Persistent comparators
 */
public abstract class PersistentComparator extends Persistent implements Comparator { 
    /**
     * Compare two object
     * @return value &lt; 0 if <code>o1</code> &lt; <code>o1</code>, 
     * 0 if <code>o1</code> == <code>o1</code>,  
     * value &gt; 0 if <code>o1</code> &gt; <code>o1</code>
     */
    public abstract int compare(Object o1, Object o2);
}

